﻿using System.IO;
using System.Text;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 텍스트 박스 작성자
    /// </summary>
    public class TextBoxWriter : TextWriter
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 컨트롤
        /// </summary>
        private Control control;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 인코딩 - Encoding

        /// <summary>
        /// 인코딩
        /// </summary>
        public override Encoding Encoding
        {
            get
            {
                return Encoding.Unicode;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - TextBoxWriter(control)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="control">컨트롤</param>
        public TextBoxWriter(Control control)
        {
            this.control = control;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 쓰기 - Write(value)

        /// <summary>
        /// 쓰기
        /// </summary>
        /// <param name="value">값</param>
        public override void Write(char value)
        {
            this.control.Text += value;
        }

        #endregion
        #region 쓰기 - Write(value)

        /// <summary>
        /// 쓰기
        /// </summary>
        /// <param name="value">값</param>
        public override void Write(string value)
        {
            this.control.Text += value;
        }

        #endregion
    }
}